//+------------------------------------------------------------------+
//|                                                    5min-momo.mq4 |
//|                                                        KittisakH |
//+------------------------------------------------------------------+

/*********************************************************************
   5 Mins Momo from High Probability Trading Setups Book
*********************************************************************/

#property copyright "KittisakH"
#property link      "kittisak.hataitham@gmail.com"


//============================================
extern   int MA_PERIOD = 20;
extern   int MA_FAST = 12;
extern   int MA_SLOW = 26;
extern   int MA_SIGNAL = 9;
extern   double Lots = 0.01;
extern   int Slippage = 3;
extern   int StopLoss = 20;
//extern   int TakeProfit = 25;
extern   int MagicNumber = 12345;
extern   int MaxPosition = 5;
extern   int TrailingStop = 15;
extern   bool Reverse = false;

//============================================
datetime CurrentBar;
double MovingAverage;
double MovingAverage_Temp;
double MACD_Current;
double MACD_Previous;
double MACD_Previous2;
double MACD_Previous3;
double MACD_Current_Temp;
double MACD_Previous_Temp;
double MACD_Previous_Temp2;
double MACD_Previous_Temp3;
int TotalOpenPositions = 0;
double NewStopLoss;
double BreakEvenPoint;


//============================================
int init() {
   if(Digits == 3 || Digits == 5) {
      Slippage *= 10;
      StopLoss *= 10;
      //TakeProfit *= 10;
      TrailingStop *= 10;
   }
   return(0);
}


//============================================
int deinit() {
   return(0);
}


//============================================
int start() {
   
   // process open position
   MoveToBreakEven();
   MoveTrailingStop();
   
   // trap for current bar
   // only process a bar once
   if (iTime(NULL,0,0) == CurrentBar) {
        return(0);
   }
   
   // processing for new bar starts
   CurrentBar = iTime(NULL,0,0);
   
   MovingAverage = iMA(NULL, 0, MA_PERIOD, 0, MODE_EMA, PRICE_CLOSE, 0);
   MACD_Current = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,0);
   MACD_Previous = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,1);
   MACD_Previous2 = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,2);
   MACD_Previous3 = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,3);
   
   // check for price crossing moving average
   if ((Close[0] > MovingAverage) && (Close[1] < MovingAverage)) {
      // long signal 
      // look back
      for (int i=0; i<5; i++) {
         MACD_Current_Temp = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,0+i);
         MACD_Previous_Temp = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,1+i);
         MACD_Previous_Temp2 = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,2+i);
         MACD_Previous_Temp3 = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,3+i);
         if ((MACD_Current_Temp >= 0) && (MACD_Previous_Temp < 0)) {
            // go long
            if(!Reverse) {
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,0,"Test",MagicNumber,0,Green);
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+StopLoss*Point,"Test",MagicNumber,0,Green);
               return(0);
            } else {
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,0,"Test",MagicNumber,0,Red);
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-StopLoss*Point,"Test",MagicNumber,0,Red);
               return(0);
            }
            
         }
      }
   } else if ((Close[0] > MovingAverage) && (Close[1] < MovingAverage)) {
      // long signal 
      // look back
      for (int j=0; j<5; j++) {
         MACD_Current_Temp = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,0+j);
         MACD_Previous_Temp = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,1+j);
         MACD_Previous_Temp2 = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,2+j);
         MACD_Previous_Temp3 = iMACD(NULL, 0, MA_FAST, MA_SLOW, MA_SIGNAL, PRICE_CLOSE, MODE_MAIN ,3+j);
         if ((MACD_Current_Temp <= 0) && (MACD_Previous_Temp > 0)) {
            // go short
            if(!Reverse) {
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,0,"Test",MagicNumber,0,Red);
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-StopLoss*Point,"Test",MagicNumber,0,Red);
               return(0);
            } else {
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,0,"Test",MagicNumber,0,Green);
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+StopLoss*Point,"Test",MagicNumber,0,Green);
               return(0);
            }
         }
      }
   }
   
   // check for macd cross negative to positive or positive to negative   
   if ((MACD_Current >= 0) && (MACD_Previous < 0) && (MACD_Previous2 < 0) && (MACD_Previous3 < 0)) {
      // long signal from macd
      // look back for price crossing ma
      for (int k=0; k<5; k++) {
         MovingAverage_Temp = iMA(NULL, 0, MA_PERIOD, 0, MODE_EMA, PRICE_CLOSE, 0+k);
         if ((Close[0+k] > MovingAverage) && (Close[1+k] < MovingAverage)) {
            // go long
            if(!Reverse) {
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,0,"Test",MagicNumber,0,Green);
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+StopLoss*Point,"Test",MagicNumber,0,Green);
               return(0);
            } else {
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,0,"Test",MagicNumber,0,Red); 
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-StopLoss*Point,"Test",MagicNumber,0,Red);
               return(0);
            }
            
         }
      }
   } else if ((MACD_Current <= 0) && (MACD_Previous > 0) && (MACD_Previous2 > 0) && (MACD_Previous3 > 0)) {
      // short signal from macd
      // look back for price crossing ma
      for (int l=0; l<5; l++) {
         MovingAverage_Temp = iMA(NULL, 0, MA_PERIOD, 0, MODE_EMA, PRICE_CLOSE, 0+l);
         if ((Close[0+l] < MovingAverage) && (Close[1+l] > MovingAverage)) {
            // go short
            if(!Reverse) {
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,0,"Test",MagicNumber,0,Red);
               OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-StopLoss*Point,"Test",MagicNumber,0,Red);
               return(0);
            } else {
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,0,"Test",MagicNumber,0,Green);
               OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+StopLoss*Point,"Test",MagicNumber,0,Green);
               return(0);
            }
         }
      }
   }

   return(0);
}

void MoveTrailingStop() {
   int total = OrdersTotal();
   for(int cnt=0; cnt<total; cnt++) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {   
         if (OrderType() == OP_BUY) {
            NewStopLoss = MovingAverage - TrailingStop*Point;
            if (NewStopLoss > OrderOpenPrice() && NewStopLoss > OrderStopLoss()) {
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(NewStopLoss,Digits),OrderTakeProfit(),0,Blue);
               return(0);
            }
         } else if (OrderType() == OP_SELL) {
            NewStopLoss = MovingAverage + TrailingStop*Point;
            if (NewStopLoss < OrderOpenPrice() && NewStopLoss < OrderStopLoss()) {
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(NewStopLoss,Digits),OrderTakeProfit(),0,Blue);
               return(0);
            }
         }
      }
   }
   return(0);
}

void MoveToBreakEven() {
   int total = OrdersTotal();
   for(int cnt=0; cnt<total; cnt++) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {   
         if (OrderType() == OP_BUY) {
            BreakEvenPoint = OrderOpenPrice() + StopLoss*Point;
            if(Bid >= BreakEvenPoint && OrderStopLoss() < OrderOpenPrice()) {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);
               return(0);
            }
         } else if (OrderType() == OP_SELL) {
            BreakEvenPoint = OrderOpenPrice() - StopLoss*Point;
            if(Ask <= BreakEvenPoint && OrderStopLoss() > OrderOpenPrice()) {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
               return(0);
            }
         }
      }
   }
   return(0);
}